#ifndef TESTSPAGHETTI_HPP
#define TESTSPAGHETTI_HPP

#include <string>
#include <map>


using ConfigMap = std::map<std::string, std::string>;


const ConfigMap Test2D {
  {"T", "0.5"},
  {"LinearReduction", "1e-8"},
  {"LinearEpsilon", "1e-10"},
  {"LinearVerbose", "0"},
  {"ConfigVerbose", "1"},
  {"level", "4"},
  {"plevel", "4"},
  {"deg", "1"},
  {"plot_tStep", "1"},
  {"sign", "-1"},
  {"degradation", "0"},
  {"project_pf", "1"},
  {"rho2", "1"},
  {"mu2", "0.0000001"},
  {"dt", "0.02"},
  {"dt_min", "0.005"},
  {"rkorder", "-227"},
  {"logfile", "log_test_2d"},
  {"DataPath", "data"},
  {"sigma_c", "28"},
  {"W_c", "0.01"},
  {"tau_r", "0.00001"},
  {"l_c", "0.001"},
  {"s_min", "0.01"},
  {"shift_g", "0.01"},
  {"mu", "1"},
  {"lambda", "2"},
  {"Problem", "ElasticPhaseFieldArc2"},
  {"reversible", "1"},
  {"plot_inelastic", "0"},
  {"angle", "90"},
  {"t_max", "0.24"},
  {"scaleAmplitude", "1.025"},
  {"height", "0"},
  {"width", "0.3"},
  {"shift", "1.25"},
  {"shift2", "-1.03"},
  {"scale_g", "1"},
  {"T", "0.5"},
  {"Mesh", "Line2_2d_16"},
  {"MeshesVerbose", "1"},
  {"MeshVerbose", "2"},
  {"ProblemExact", "0"},
  {"use_pf_vector", "1"},
  {"StressProjection", "0"},
  {"s_min2", "0"},
  {"RescaleEnergy", "0"},
  {"Model", "dGElasticity"},
  {"rho", "1.0"},
  {"lambda2", "0"},
  {"eta", "0.0001"},
  {"eta_stat", "0.000001"},
  {"Pobs", "-0.1 0.5"},
  {"DebugLevel", "0"},
  {"Verbose", "6"},
  {"TimeLevel", "3"},
  {"vtkplot", "1"},
  {"TimeSeries", "uniform"},
  {"Preconditioner", "PointBlockGaussSeidel"},
  {"LinearSolver", "GMRES"},
  {"LinearSteps", "10000"},
  {"precision", "10"},
  {"Overlap", "dG1"},
  {"TestValue", "1.4883366256944095"}
//  {"TestValue", "1.488377618"} old value
};

const ConfigMap Test3D{
  {"plot_tStep", "1"},
  {"dt", "0.01"},
  {"dt_min", "0.01"},
  {"angle", "70"},
  {"angle2", "20"},
  {"sigma_c", "3.7"},
  {"T", "0.8"},
  {"sign", "1"},
  {"t_max", "0.24"},
  {"width", "0.55"},
  {"scaleProfile", "0"},
  {"rho", "1"},
  {"mu", "1"},
  {"lambda", "2"},
  {"logfile", "log_test_3d"},
  {"DataPath", "data"},
  {"l_c", "0.01"},
  {"tau_r", "0.000001"},
  {"W_c", "0.01"},
  {"s_min", "0.01"},
  {"ConfigVerbose", "1"},
  {"level", "2"},
  {"plevel", "1"},
  {"deg", "1"},
  {"Mesh", "Line2_3d_4"},
  {"MeshesVerbose", "1"},
  {"MeshVerbose", "2"},
  {"shift_g", "0.01"},
  {"height", "1"},
  {"scaleAmplitude", "1.025"},
  {"Problem", "ElasticPhaseFieldArc_3d"},
  {"reversible", "1"},
  {"plot_inelastic", "0"},
  {"shift", "1.02"},
  {"shift2", "-1.03"},
  {"scale_g", "1"},
  {"degradation", "0"},
  {"t0", "0"},
  {"use_pf_vector", "1"},
  {"StressProjection", "0"},
  {"s_min2", "0"},
  {"RescaleEnergy", "0"},
  {"Model", "dGElasticity"},
  {"eta", "0.0001"},
  {"eta_stat", "0.000001"},
  {"eta_dyn", "0.01"},
  {"X0", "-100"},
  {"X1", "100"},
  {"Y0", "-100"},
  {"Y1", "100"},
  {"ProblemExact", "0"},
  {"Pobs", "-0.1 0.5"},
  {"DebugLevel", "0"},
  {"Verbose", "6"},
  {"TimeLevel", "3"},
  {"vtkplot", "1"},
  {"TimeSeries", "uniform"},
  {"rkorder", "-227"},
  {"Preconditioner", "PointBlockJacobi"},
  {"LinearSolver", "GMRES"},
  {"LinearSteps", "10000"},
  {"LinearReduction", "1e-8"},
  {"LinearEpsilon", "1e-13"},
  {"LinearVerbose", "0"},
  {"precision", "8"},
  {"Overlap", "dG1"},
  {"first_receiver", "1 1"},
  {"last_receiver", "3 3"},
  {"receiver_count", "10"},
  {"receive_times", "0 2 0.01"},
  {"measurement_radius", "0.5"},
  {"TestValue", "0.16847587700086322,"}
//  {"TestValue", "0.16838301754725027"} old value
};

#endif //TESTSPAGHETTI_HPP
